## webkit2gtk 2.50.5

=== debian/changelog ===
webkit2gtk (2.50.5-1) unstable; urgency=medium

  * New upstream release.
  * debian/control.in:
    - Build depend on libxml2-utils. glib-compile-resources uses xmllint
      (Jeremy Bícha).
    - Remove "Priority: optional" field, this is now redundant (Debian
      policy 4.7.3).
    - Update Standards-Version to 4.7.3.
  * debian/rules:
    - Disable native SIMD on Ubuntu (LP: #2121516) (Jeremy Bícha).
    - Build with -no-integrated-cpp to further reduce memory usage on some
      32-bit architectures (Closes: #1125347).
    - Use gcc on armhf instead of clang-19 (Closes: #1124051)
      (LP: #2103459).
    - Use --param ggc-min-expand=10 on armhf and powerpc to reduce memory
      usage even more.
  * debian/patches/no-must-tail.patch:
    - Disable musttail on sh4 and m68k (Closes: #1125380).
  * Update copyright years.

 -- Alberto Garcia <berto@igalia.com>  Tue, 10 Feb 2026 14:44:43 +0100
